Loading...
Searching...
No Matches
Dune::TypeTree::TransformTree< SourceTree, Transformation, Tag, recursive > Struct Template Reference
dune-typetree » Transformation

Transform a TypeTree. More...

`#include <dune/typetree/transformation.hh>`

## Public Types

typedef transformed_type | type
| The type of the transformed tree.
typedef type | Type

## Static Public Member Functions

static transformed_type | transform (const SourceTree &s, const Transformation &t=Transformation())
| Apply transformation to an existing tree s.
static transformed_type | transform (const SourceTree &s, Transformation &t)
| Apply transformation to an existing tree s.
static transformed_type | transform (std::shared_ptr< const SourceTree > sp, const Transformation &t=Transformation())
| Apply transformation to an existing tree s.
static transformed_type | transform (std::shared_ptr< const SourceTree > sp, Transformation &t)
| Apply transformation to an existing tree s.
static transformed_storage_type | transform_storage (std::shared_ptr< const SourceTree > sp, const Transformation &t=Transformation())
static transformed_storage_type | transform_storage (std::shared_ptr< const SourceTree > sp, Transformation &t)

## Detailed Description

template<typename SourceTree, typename Transformation, typename Tag = StartTag, bool recursive = true>
struct Dune::TypeTree::TransformTree< SourceTree, Transformation, Tag, recursive >

Transform a TypeTree.

This struct can be used to apply a transformation to a given TypeTree. It exports the type of the resulting (transformed) tree and contains methods to actually transform tree instances.

Template Parameters

  SourceTree | = The TypeTree that should be transformed.
  Transformation | = The Transformation to apply to the TypeTree.
  Tag | = This parameter is an implementation detail and must always be set to its default value.
  recursive | = This parameter is an implementation detail and must always be set to its default value.

## Member Typedef Documentation

## Type

template<typename SourceTree, typename Transformation, typename Tag = StartTag, bool recursive = true>

typedef type Dune::TypeTree::TransformTree< SourceTree, Transformation, Tag, recursive >::Type

## type

template<typename SourceTree, typename Transformation, typename Tag = StartTag, bool recursive = true>

typedef transformed_type Dune::TypeTree::TransformTree< SourceTree, Transformation, Tag, recursive >::type

The type of the transformed tree.

## Member Function Documentation

## transform() [1/4]

template<typename SourceTree, typename Transformation, typename Tag = StartTag, bool recursive = true>

transformed_type Dune::TypeTree::TransformTree< SourceTree, Transformation, Tag, recursive >::transform | ( | const SourceTree & | s,
|  | const Transformation & | t = Transformation() )

inline static

Apply transformation to an existing tree s.

## transform() [2/4]

template<typename SourceTree, typename Transformation, typename Tag = StartTag, bool recursive = true>

transformed_type Dune::TypeTree::TransformTree< SourceTree, Transformation, Tag, recursive >::transform | ( | const SourceTree & | s,
|  | Transformation & | t )

inline static

Apply transformation to an existing tree s.

## transform() [3/4]

template<typename SourceTree, typename Transformation, typename Tag = StartTag, bool recursive = true>

transformed_type Dune::TypeTree::TransformTree< SourceTree, Transformation, Tag, recursive >::transform | ( | std::shared_ptr< const SourceTree > | sp,
|  | const Transformation & | t = Transformation() )

inline static

Apply transformation to an existing tree s.

## transform() [4/4]

template<typename SourceTree, typename Transformation, typename Tag = StartTag, bool recursive = true>

transformed_type Dune::TypeTree::TransformTree< SourceTree, Transformation, Tag, recursive >::transform | ( | std::shared_ptr< const SourceTree > | sp,
|  | Transformation & | t )

inline static

Apply transformation to an existing tree s.

## transform_storage() [1/2]

template<typename SourceTree, typename Transformation, typename Tag = StartTag, bool recursive = true>

transformed_storage_type Dune::TypeTree::TransformTree< SourceTree, Transformation, Tag, recursive >::transform_storage | ( | std::shared_ptr< const SourceTree > | sp,
|  | const Transformation & | t = Transformation() )

inline static

Apply transformation to storage type of an existing tree, returning a heap-allocated storage type instance of the transformed tree.

## transform_storage() [2/2]

template<typename SourceTree, typename Transformation, typename Tag = StartTag, bool recursive = true>

transformed_storage_type Dune::TypeTree::TransformTree< SourceTree, Transformation, Tag, recursive >::transform_storage | ( | std::shared_ptr< const SourceTree > | sp,
|  | Transformation & | t )

inline static

Apply transformation to storage type of an existing tree, returning a heap-allocated storage type instance of the transformed tree.

The documentation for this struct was generated from the following file:

- transformation.hh